<?php

declare(strict_types=1);

namespace Dedi\SyliusImportExportPlugin\Reader;

use Port\Reader;
use Port\Reader\ReaderFactory;

class TxtReaderFactory implements ReaderFactory
{
    protected ?int $headerRowNumber = null;

    private string $delimiter;

    private bool $trim;

    private string $enclosure;

    private bool $utf8Encode;

    public function __construct(
        ?int $headerRowNumber = null,
        string $delimiter = '|',
        string $enclosure = '"',
        bool $trim = true,
        bool $utf8Encode = false
    ) {
        $this->headerRowNumber = $headerRowNumber;
        $this->delimiter = $delimiter;
        $this->enclosure = $enclosure;
        $this->trim = $trim;
        $this->utf8Encode = $utf8Encode;
    }

    public function getReader(\SplFileObject $file): Reader
    {
        return new TxtReader($file, $this->headerRowNumber, $this->delimiter, $this->enclosure, $this->trim, $this->utf8Encode);
    }
}
