<?php

declare(strict_types=1);

namespace Dedi\SyliusImportExportPlugin\Registry;

use Dedi\SyliusImportExportPlugin\Exporter\ExporterInterface;

class ExporterRegistry
{
    /** @var ExporterInterface[] */
    private iterable $exporters;

    public function __construct(iterable $exporters)
    {
        $this->exporters = $exporters;
    }

    public function get(string $identifier): ExporterInterface
    {
        foreach ($this->exporters as $exporter) {
            if ($exporter->getIdentifier() === $identifier) {
                return $exporter;
            }
        }

        throw new \Exception("No exporter found with identifier {$identifier}");
    }
}
